#include <stdio.h>
#include <stdlib.h>
#include "gmp.h"
#include <time.h>
#include<unistd.h>
int main()
{
     printf("RSA - ENCRYPTION\n");
    printf("RSA - Calculate p,q, N \n");
    gmp_randstate_t stat;
    int primetest;
    int prime_bits;
    mpz_t seed;
    mpz_t p,q,N;
    mpz_init(p);
    mpz_init(q);
    mpz_init(N);

    printf("Enter RSA Encryption bits: ");
    scanf("%d",&prime_bits);
    gmp_randinit(stat, GMP_RAND_ALG_LC, 120);
    mpz_set_ui(seed, (unsigned) time(NULL)%getpid());
    gmp_randseed(stat, seed);

    mpz_urandomb(p, stat, prime_bits);
    primetest = mpz_probab_prime_p(p, 10);

     if (primetest != 0) {
        printf("p is prime\n");
    } else {
        mpz_nextprime(p, p);
    }
    gmp_printf("p = %Zd\n",p);
    printf("\n");


    mpz_urandomb(q, stat, prime_bits);
    primetest = mpz_probab_prime_p(q, 10);

     if (primetest != 0) {
        printf("q is prime\n");
    } else {
        mpz_nextprime(q, q);
    }
    gmp_printf("q = %Zd\n",q);
    printf("\n");

    mpz_mul(N,p,q);
    gmp_printf("N = %Zd\n",N);
    printf("\n");
    gmp_randclear(stat);
    return 0;
}
